Browse Source

Récupération modifications locales

Charly 6 years ago
parent
commit
6bbdc8945a
3 changed files with 573 additions and 0 deletions
  1. 2 0
      cotisation-reminder1.format
  2. 243 0
      nagios/check_file_exists_glob
  3. 328 0
      nagios/check_service.sh

+ 2 - 0
cotisation-reminder1.format

@@ -7,6 +7,8 @@ La date anniversaire de ton adhésion à Franciliens.net était le {datefin:%d/%
 
 Nous n'avons pas reçu ta cotisation annuelle, mais espèrons que tu souhaite toujours soutenir l'association et ses actions. Nous te rapellons donc qu'il suffit de régler 15 EUR chaque année, de préference par virement sur le compte de l’association. 
 
+Il se peut que tu aies déjà effectué le virement, mais que nous l'ayons pas encore traité, auquel cas tu peut ignorer ce mesage. 
+
 Les coordonnées bancaires de Franciliens.net sont
 IBAN: {bank_account_iban} ({bank_account_bank})
 

+ 243 - 0
nagios/check_file_exists_glob

@@ -0,0 +1,243 @@
+#!/bin/bash
+# Copyright(C) 2013 Mark Clarkson <mark.clarkson@smorg.co.uk>
+#
+#    This software is provided under the terms of the GNU
+#    General Public License (GPL), as published at: 
+#    http://www.gnu.org/licenses/gpl.html .
+#
+# File:     check_file_exists_glob
+# Date:     06 May 2013
+# Version:  0.10
+# Modified: 23 Jul 2015 by Mark Clarkson <mark.clarkson@smorg.co.uk>
+#             Allow '*' as FILE.
+#
+# Purpose:  Check for existence (or not) of a file.
+#
+# Notes:
+#
+
+
+# ---------------------------------------------------------------------------
+# DEFAULTS (Change as necessary)
+# ---------------------------------------------------------------------------
+
+# ---------------------------------------------------------------------------
+# DON'T TOUCH ANYTHING BELOW
+# ---------------------------------------------------------------------------
+
+ME="$0"
+CMDLINE="$@"
+TRUE=1
+FALSE=0
+VERSION="0.10"
+OK=0
+WARN=1
+CRIT=2
+UNKN=3
+
+USESUDO=0
+WITHPERF=0
+SUDO="sudo "
+
+DIR=
+FILE=
+declare -i INVERTFILE=0 INVERTDIR=0 USESUDO=0 WITHPERF=0
+declare -i ALERTDIR=0 CRITLVL=1 WARNLVL=1 NFILES=0
+
+# ---------------------------------------------------------------------------
+main()
+# ---------------------------------------------------------------------------
+{
+    local retval txt msg
+
+    retval=$OK
+
+    parse_options "$@"
+
+    sanity_checks
+
+    # Fill in the stats variables 
+    do_check
+
+    txt="OK:"
+    [[ $INVERTFILE -eq 0 ]] && msg="File '$FILE' is present, good."
+    [[ $INVERTFILE -eq 1 ]] && msg="File '$FILE' is absent, good."
+    if [[ $ALERTFILE -eq 1 ]]; then
+        retval=$CRIT
+        txt="CRITICAL: "
+        [[ $NFILES -ge $WARNLVL ]] && { txt="WARNING: "; retval=$WARN; }
+        [[ $NFILES -ge $CRITLVL ]] && { txt="CRITICAL: "; retval=$CRIT; }
+        [[ $NFILES -lt $WARNLVL && $INVERTFILE -eq 1 ]] && { txt="OK: "; retval=$OK; }
+        msg="File does not exist, '$FILE'."
+        [[ $INVERTFILE -eq 1 ]] && msg="File '$FILE' found in '$DIR'."
+        [[ $ALERTDIR -eq 1 ]] && msg+=" Directory does not exist, '$DIR'."
+    elif [[ $ALERTDIR -eq 1 ]]; then
+        retval=$CRIT
+        txt="CRITICAL: "
+        msg="Directory does not exist, '$DIR'."
+    fi
+
+    out="$txt $msg"
+    [[ $WITHPERF -eq 1 ]] && {
+        : $((++NFILES));: $((--NFILES))
+        out="$out | \"$FILE\"=$NFILES"
+    }
+
+    echo "$out"
+
+    exit $retval
+}
+
+# ---------------------------------------------------------------------------
+sanity_checks()
+# ---------------------------------------------------------------------------
+{
+    [[ -z $DIR ]] && {
+        usage
+        echo "ERROR: The DIRectory must be specified."
+        exit 0
+    }
+
+    [[ -z $FILE ]] && {
+        usage
+        echo "ERROR: The FILE name must be specified."
+        exit 0
+    }
+    
+    [[ $WARNLVL -gt $CRITLVL ]] && {
+        usage
+        echo "ERROR: The warning level is greater than the critical level."
+        exit 0
+    }
+}
+
+# ----------------------------------------------------------------------------
+usage()
+# ----------------------------------------------------------------------------
+{
+    echo
+    echo "`basename $ME` - Alert if a FILE does not exist."
+    echo
+    echo "Usage: `basename $ME` [options] -d DIR FILE"
+    echo
+    echo " FILE    :  The file to search for. Can glob using '*' etc, but"
+    echo "            place file names with glob patterns within quotes."
+    echo "            Mandatory. The FILE must always be specified."
+    echo " -d DIR  :  Base directory to search in."
+    echo "            Mandatory option - the DIR must always be specified."
+    echo " -i      :  Invert FILE, so alert if FILE does exist."
+    echo " -I      :  Alert if DIR does not exist."
+    echo " -p      :  Add performance data output for graphing."
+    echo " -w NUM  :  Warning alert if >=NUM files are found and invert"
+    echo "            files '-i' is on. (Default is: 1)"
+    echo " -c NUM  :  Critical alert if >=NUM files are found and invert"
+    echo "            files '-i' is on. (Default is: 1)"
+    echo " -h      :  Display this help text."
+    echo
+    echo "Example:"
+    echo
+    echo "  Check that /tmp/dir/file exists."
+    echo
+    echo "    ./`basename $ME` -d /tmp/dir file"
+    echo
+    echo "  Check that /tmp/dir/file does NOT exist."
+    echo
+    echo "    ./`basename $ME` -d /tmp/dir -i file"
+    echo
+    echo "  Again check that /tmp/dir/file does NOT exist but this time alert"
+    echo "  if the directory it could be found in, /tmp/dir, is missing."
+    echo
+    echo "    ./`basename $ME` -d /tmp/dir -i -I file"
+    echo
+    echo "  Check for files matching the glob 'fi*' and alert if found in"
+    echo "  /tmp/dir. Alert if /tmp/dir does not exist. Provide performance"
+    echo "  data for graphing, showing the number of files matching the"
+    echo "  glob pattern."
+    echo
+    echo "    ./`basename $ME` -d /tmp/dir -i -I -p \"fi*\""
+    echo
+    echo "  Same as previous but only alert if thresholds are exceeded. In"
+    echo "  this case issue a warning alert when there are 20 or more files"
+    echo "  found, critical for 30 or more."
+    echo
+    echo "    ./`basename $ME` -d /tmp/dir -i -I -p -w 20 -c 30 \"fi*\""
+    echo
+}
+
+# ---------------------------------------------------------------------------
+do_check()
+# ---------------------------------------------------------------------------
+{
+    local -i found=0
+
+    cd /
+    [[ $INVERTFILE -eq 0 && $INVERTDIR -eq 1 && ! -d $DIR ]] && \
+        { ALERTDIR=1 ; return ; }
+    [[ $INVERTFILE -eq 1 && $INVERTDIR -eq 1 && ! -d $DIR ]] && \
+        ALERTDIR=1
+    [[ $INVERTFILE -eq 0 ]] && {
+        found=`find $DIR -mindepth 1 -maxdepth 1 -name "$FILE" 2>/dev/null | wc -l`
+        NFILES=$found
+        [[ $found -eq 0 ]] && {
+            ALERTFILE=1
+            return
+        }
+    }
+    [[ $INVERTFILE -eq 1 ]] && {
+        found=`find $DIR -mindepth 1 -maxdepth 1 -name "$FILE" 2>/dev/null | wc -l`
+        NFILES=$found
+        [[ $found -ge 1 ]] && {
+            ALERTFILE=1
+            return
+        }
+    }
+}
+
+# ----------------------------------------------------------------------------
+parse_options()
+# ----------------------------------------------------------------------------
+# Purpose:      Parse program options and set globals.
+# Arguments:    None
+# Returns:      Nothing
+{
+    set -- "$@"
+    while true
+    do
+        case $1 in
+            -d) DIR="$2" ; shift
+                # Append '/' if not already appended
+                DIR="${DIR%/}${DIR:+/}"
+            ;;
+            -i) INVERTFILE=1
+            ;;
+            -I) INVERTDIR=1
+            ;;
+            -s) USESUDO=1
+            ;;
+            -p) WITHPERF=1
+            ;;
+            -h) usage
+                exit 0
+            ;;
+            -w) WARNLVL="$2" ; shift
+            ;;
+            -c) CRITLVL="$2" ; shift
+            ;;
+            ?*) FILE="$1"
+                [[ -n $2 ]] && {
+                    usage
+                    echo "ERROR: Only one filename allowed."
+                    exit 4
+                }
+            ;;
+        esac
+        shift 1 || break
+    done
+
+    [[ $USESUDO -ne 1 ]] && SUDO=
+}
+
+main "$@"
+
+exit 0
+

+ 328 - 0
nagios/check_service.sh

@@ -0,0 +1,328 @@
+#!/usr/bin/env bash
+
+# Author: Jon Schipp
+# 2015-03-09 [Pascal Hegy] - Add sudo for linux
+# 2015-03-09 [Pascal Hegy] - Change USER variable to USERNAME to avoid the use and confusion with the USER env variable
+# 2017-08-30 [Roberto Leibman] - Reordered checks to make sure dead and inactive get checked first
+
+########
+# Examples:
+
+# 1.) List services for osx
+# $ ./check_service.sh -l -o osx
+#
+# 2.) Check status of SSH service on a linux machine
+# $ ./check_service.sh -o linux -s sshd
+
+# 3.) Manually select service management tool and service
+# $ ./check_service.sh -o linux -t "service rsyslog status"
+
+# Nagios Exit Codes
+OK=0
+WARNING=1
+CRITICAL=2
+UNKNOWN=3
+
+usage()
+{
+cat <<EOF
+
+Check status of system services for Linux, FreeBSD, OSX, and AIX.
+
+     Options:
+        -s <service>    Specify service name
+        -l              List services
+        -o <os>         OS type, "linux/osx/freebsd/aix"
+        -u <user>       User if you need to ``sudo -u'' for launchctl (def: nagios, linux and osx only)
+        -t <tool>       Manually specify service management tool (def: autodetect) with status and service
+                        e.g. ``-t "service nagios status"''
+
+
+EOF
+}
+
+argcheck() {
+# if less than n argument
+if [ $ARGC -lt $1 ]; then
+        echo "Missing arguments! Use \`\`-h'' for help."
+        exit 1
+fi
+}
+
+os_check() {
+if [ "$OS" == null ]; then
+	unamestr=$(uname)
+        if [[ $unamestr == 'Linux' ]]; then
+                OS='linux'
+        elif [[ $unamestr == 'FreeBSD' ]]; then
+               OS='freebsd'
+        elif [[ $unamestr == 'Darwin' ]]; then
+               OS='osx'	       
+        else
+                echo "OS not recognized, Use \`-o\` and specify the OS as an argument"
+                exit 3
+        fi
+fi
+}
+
+
+
+determine_service_tool() {
+TRUST_EXIT_CODE=0
+if [[ $OS == linux ]]; then
+        if command -v systemctl >/dev/null 2>&1; then
+                SERVICETOOL="systemctl status $SERVICE | grep 'Active: '"
+                LISTTOOL="systemctl"
+                if [ $USERNAME ]; then
+                    SERVICETOOL="sudo -u $USERNAME systemctl status $SERVICE | grep 'Active: '"
+                    LISTTOOL="sudo -u $USERNAME systemctl"
+                fi
+#		TRUST_EXIT_CODE=1
+        elif command -v initctl >/dev/null 2>&1; then
+                SERVICETOOL="status $SERVICE"
+                LISTTOOL="initctl list"
+                if [ $USERNAME ]; then
+                    SERVICETOOL="sudo -u $USERNAME status $SERVICE"
+                    LISTTOOL="sudo -u $USERNAME initctl list"
+                fi
+        elif command -v service >/dev/null 2>&1; then
+                SERVICETOOL="service $SERVICE status"
+                LISTTOOL="service --status-all"
+                if [ $USERNAME ]; then
+                    SERVICETOOL="sudo -u $USERNAME service $SERVICE status"
+                    LISTTOOL="sudo -u $USERNAME service --status-all"
+                fi
+        elif command -v chkconfig >/dev/null 2>&1; then
+                SERVICETOOL=chkconfig
+                LISTTOOL="chkconfig --list"
+                if [ $USERNAME ]; then
+                    SERVICETOOL="sudo -u $USERNAME chkconfig"
+                    LISTTOOL="sudo -u $USERNAME chkconfig --list"
+                fi
+        elif [ -f /etc/init.d/$SERVICE ] || [ -d /etc/init.d ]; then
+                SERVICETOOL="/etc/init.d/$SERVICE status | tail -1"
+                LISTTOOL="ls -1 /etc/init.d/"
+                if [ $USERNAME ]; then
+                    SERVICETOOL="sudo -u $USERNAME /etc/init.d/$SERVICE status | tail -1"
+                    LISTTOOL="sudo -u $USERNAME ls -1 /etc/init.d/"
+                fi
+        else
+                echo "Unable to determine the system's service tool!"
+                exit 1
+        fi
+fi
+
+if [[ $OS == freebsd ]]; then
+        if command -v service >/dev/null 2>&1; then
+                SERVICETOOL="service $SERVICE status"
+                LISTTOOL="service -l"
+        elif [ -f /etc/rc.d/$SERVICE ] || [ -d /etc/rc.d ]; then
+                SERVICETOOL="/etc/rc.d/$SERVICE status"
+                LISTTOOL="ls -1 /etc/rc.d/"
+        else
+                echo "Unable to determine the system's service tool!"
+                exit 1
+        fi
+fi
+
+if [[ $OS == osx ]]; then
+        if [ -f /usr/sbin/serveradmin >/dev/null 2>&1 ] && serveradmin list | grep "$SERVICE" 2>&1 >/dev/null; then
+                SERVICETOOL="serveradmin status $SERVICE"
+                LISTTOOL="serveradmin list"
+        elif [ -f /Applications/Server.app/Contents/ServerRoot/usr/sbin/serveradmin >/dev/null 2>&1 ] && \
+               /Applications/Server.app/Contents/ServerRoot/usr/sbin/serveradmin list | \
+                grep "$SERVICE" 2>&1 >/dev/null; then
+                SERVICETOOL="/Applications/Server.app/Contents/ServerRoot/usr/sbin/serveradmin status $SERVICE"
+                LISTTOOL="/Applications/Server.app/Contents/ServerRoot/usr/sbin/serveradmin list"
+        elif command -v launchctl >/dev/null 2>&1; then
+                SERVICETOOL="launchctl list | grep -v ^- | grep $SERVICE || echo $SERVICE not running! "
+                LISTTOOL="launchctl list"
+                if [ $USERNAME ]; then
+                        SERVICETOOL="sudo -u $USERNAME launchctl list | grep -v ^- | grep $SERVICE || echo $SERVICE not running! "
+                        LISTTOOL="sudo -u $USERNAME launchctl list"
+                fi
+        elif command -v service >/dev/null 2>&1; then
+                SERVICETOOL="service --test-if-configured-on $SERVICE"
+                LISTTOOL="service list"
+        else
+                echo "Unable to determine the system's service tool!"
+                exit 1
+        fi
+fi
+
+if [[ $OS == aix ]]; then
+        if command -v lssrc >/dev/null 2>&1; then
+                SERVICETOOL="lssrc -s $SERVICE | grep -v Subsystem"
+                LISTTOOL="lssrc -a"
+        else
+                echo "Unable to determine the system's service tool!"
+                exit 1
+        fi
+fi
+}
+
+ARGC=$#
+LIST=0
+MANUAL=0
+OS=null
+SERVICETOOL=null
+LISTTOOL=null
+SERVICE=".*"
+#USERNAME=nagios
+
+argcheck 1
+
+while getopts "hls:o:t:u:" OPTION
+do
+     case $OPTION in
+         h)
+             usage
+             exit 0
+             ;;
+         l)
+             LIST=1
+             ;;
+         s)
+             SERVICE="$OPTARG"
+             ;;
+         o)
+             if [[ "$OPTARG" == linux ]]; then
+                     OS="$OPTARG"
+             elif [[ "$OPTARG" == osx ]]; then
+                     OS="$OPTARG"
+             elif [[ "$OPTARG" == freebsd ]]; then
+                     OS="$OPTARG"
+             elif [[ "$OPTARG" == aix ]]; then
+                     OS="$OPTARG"
+             else
+                     echo "Unknown type!"
+                     exit 1
+             fi
+             ;;
+         t)
+             MANUAL=1
+             MANUALSERVICETOOL="$OPTARG"
+             ;;
+         u)
+             USERNAME="$OPTARG"
+             ;;
+         \?)
+             exit 1
+             ;;
+     esac
+done
+
+os_check
+
+if [ $MANUAL -eq 1 ]; then
+SERVICETOOL=$MANUALSERVICETOOL
+else
+determine_service_tool
+fi
+
+# -l conflicts with -t                                                                                                                                                   
+if [ $MANUAL -eq 1 ] && [ $LIST -eq 1 ]; then
+    echo "Options conflict: \`\`-t'' and \`\`-l''"
+    exit 2
+fi
+
+if [ $LIST -eq 1 ]; then
+        if [[ $LISTTOOL != null ]]; then
+                $LISTTOOL
+                exit 0
+        else
+                echo "OS not specified! Use \`\`-o''"
+                exit 2
+        fi
+fi
+
+# Check the status of a service
+STATUS_MSG=$(eval "$SERVICETOOL" 2>&1)
+EXIT_CODE=$?
+
+## Exit code from the service tool - if it's non-zero, we should
+## probably return CRITICAL.  (though, in some cases UNKNOWN would
+## probably be more appropriate)
+[ $EXIT_CODE -ne 0 ] && echo "$STATUS_MSG" && exit $CRITICAL
+
+## For systemd and most systems, $EXIT_CODE can be trusted - if it's 0, the service is running.
+## Ref https://github.com/jonschipp/nagios-plugins/issues/15
+[ $TRUST_EXIT_CODE -eq 1 ] && [ $EXIT_CODE -eq 0 ] && echo "$STATUS_MSG" && exit $OK 
+
+case $STATUS_MSG in
+
+*stop*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*STOPPED*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*not*running*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*inactive*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*dead*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*running*)
+        echo "$STATUS_MSG"
+        exit $OK
+        ;;
+*RUNNING*)
+        echo "$STATUS_MSG"
+        exit $OK
+        ;;
+*SUCCESS*)
+        echo "$STATUS_MSG"
+        exit $OK
+        ;;
+*[eE]rr*)
+        echo "Error in command: $STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*[fF]ailed*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*[eE]nable*)
+        echo "$STATUS_MSG"
+        exit $OK
+        ;;
+*[dD]isable*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*[cC]annot*)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+*[aA]ctive*)
+        echo "$STATUS_MSG"
+        exit $OK
+        ;;
+*Subsystem*not*on*file)
+        echo "$STATUS_MSG"
+        exit $CRITICAL
+        ;;
+[1-9][1-9]*)
+        echo "$SERVICE running: $STATUS_MSG"
+        exit $OK
+        ;;
+"")
+	echo "$SERVICE is not running: no output from service command"
+	exit $CRITICAL
+	;;
+*)
+        echo "Unknown status: $STATUS_MSG"
+        echo "Is there a typo in the command or service configuration?: $STATUS_MSG"
+        exit $UNKNOWN
+        ;;
+esac
+